#include "fbo.h"

void
fbo_init(FBO* self)
{
	glGenFramebuffers(1, &self->handle);
}

void
fbo_bind(FBO* self)
{
	glBindFramebuffer(GL_FRAMEBUFFER, self->handle);
}

void
fbo_unbind(void)
{
	glBindFramebuffer(GL_FRAMEBUFFER, 0);
}

void
fbo_rbo_set(RBO* rbo)
{
	glFramebufferRenderbuffer(GL_FRAMEBUFFER, GL_DEPTH_STENCIL_ATTACHMENT, GL_RENDERBUFFER, rbo->handle);
}

void
fbo_texture_set(Texture* texture)
{
	glFramebufferTexture2D(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, texture->handle, 0);
}

void
fbo_free(FBO* self)
{
	glDeleteFramebuffers(1, &self->handle);
	memset(self, '\0', sizeof(FBO));
}
