#pragma once

#include "../../entity/utility/entity_timer.h"
#include "../../component/visual/component_atlas.h"

typedef struct Animation
{
	u32* frameIndices;
	u32 count;
	u32 length;
	bool isLoop;
} Animation;

typedef struct ComponentAnimation
{
	Component component;
	EntityID timer;
	u32 frame;
	bool isFinished;
	Animation animation;
} ComponentAnimation;

void component_animation_add(ComponentAnimation* self, ECS* ecs);
void component_animation_delete(ComponentAnimation* self, ECS* ecs);
void component_animation_tick(ComponentAnimation* self, ECS* ecs);
void component_animation_set(ComponentAnimation* self, ECS* ecs, Animation* animation);
void component_animation_init(ComponentAnimation* self, ECS* ecs, Animation* animation);

static const ComponentInfo COMPONENT_ANIMATION_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			(ECSFunction)component_animation_add,
			(ECSFunction)component_animation_delete,
			(ECSFunction)component_animation_tick,
			NULL,
			NULL
		}
	},
	.type = COMPONENT_ANIMATION,
	.size = sizeof(ComponentAnimation)
};
