#pragma once

#include "component_animation.h"
#include "../game/component_world_object.h"
#include "../game/component_player_control.h"

static const f32 ANIMATION_PLAYER_RUN_DISTANCE_MAX = 50.0f;
static const u32 ANIMATION_PLAYER_RUN_TIMER = 20;
static const u32 ANIMATION_PLAYER_RUN_TIMER_MIN = 5;

#define ANIMATION_PLAYER_COUNT ANIMATION_PLAYER_LUNGE_DOWN + 1
typedef enum AnimationPlayerType
{
	ANIMATION_PLAYER_IDLE_LEFT,
	ANIMATION_PLAYER_RUN_LEFT,
	ANIMATION_PLAYER_LUNGE_LEFT,
	ANIMATION_PLAYER_IDLE_RIGHT,
	ANIMATION_PLAYER_RUN_RIGHT,
	ANIMATION_PLAYER_LUNGE_RIGHT,
	ANIMATION_PLAYER_IDLE_UP,
	ANIMATION_PLAYER_RUN_UP,
	ANIMATION_PLAYER_LUNGE_UP,
	ANIMATION_PLAYER_IDLE_DOWN,
	ANIMATION_PLAYER_RUN_DOWN,
	ANIMATION_PLAYER_LUNGE_DOWN
} AnimationPlayerType;

#define ANIMATION_PLAYER_ACTION_COUNT (ANIMATION_PLAYER_ACTION_LUNGE + 1)
typedef enum AnimationPlayerActionType
{
	ANIMATION_PLAYER_ACTION_IDLE,
	ANIMATION_PLAYER_ACTION_RUN,
	ANIMATION_PLAYER_ACTION_LUNGE
} AnimationPlayerActionType;

#define ANIMATION_PLAYER_IDLE_LEFT_COUNT 1
static const u32 ANIMATION_PLAYER_IDLE_LEFT_FRAME_INDICES[ANIMATION_PLAYER_IDLE_LEFT_COUNT] = {0};
static const struct Animation ANIMATION_PLAYER_IDLE_LEFT_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_IDLE_LEFT_FRAME_INDICES,
	.count = ANIMATION_PLAYER_IDLE_LEFT_COUNT,
	.length = 0,
	.isLoop = true
};

#define ANIMATION_PLAYER_RUN_LEFT_COUNT 3
static const u32 ANIMATION_PLAYER_RUN_LEFT_FRAME_INDICES[ANIMATION_PLAYER_RUN_LEFT_COUNT] = {1, 2, 3};
static const struct Animation ANIMATION_PLAYER_RUN_LEFT_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_RUN_LEFT_FRAME_INDICES,
	.count = ANIMATION_PLAYER_RUN_LEFT_COUNT,
	.length = 20,
	.isLoop = true
};


#define ANIMATION_PLAYER_LUNGE_LEFT_COUNT 1
static const u32 ANIMATION_PLAYER_LUNGE_LEFT_FRAME_INDICES[ANIMATION_PLAYER_LUNGE_LEFT_COUNT] = {4};
static const struct Animation ANIMATION_PLAYER_LUNGE_LEFT_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_LUNGE_LEFT_FRAME_INDICES,
	.count = ANIMATION_PLAYER_LUNGE_LEFT_COUNT,
	.length = 0,
	.isLoop = true
};

#define ANIMATION_PLAYER_IDLE_RIGHT_COUNT 1
static const u32 ANIMATION_PLAYER_IDLE_RIGHT_FRAME_INDICES[ANIMATION_PLAYER_IDLE_RIGHT_COUNT] = {5};
static const struct Animation ANIMATION_PLAYER_IDLE_RIGHT_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_IDLE_RIGHT_FRAME_INDICES,
	.count = ANIMATION_PLAYER_IDLE_RIGHT_COUNT,
	.length = 0,
	.isLoop = true
};

#define ANIMATION_PLAYER_RUN_RIGHT_COUNT 3
static const u32 ANIMATION_PLAYER_RUN_RIGHT_FRAME_INDICES[ANIMATION_PLAYER_RUN_RIGHT_COUNT] = {6, 7, 8};
static const struct Animation ANIMATION_PLAYER_RUN_RIGHT_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_RUN_RIGHT_FRAME_INDICES,
	.count = ANIMATION_PLAYER_RUN_RIGHT_COUNT,
	.length = 20,
	.isLoop = true
};

#define ANIMATION_PLAYER_LUNGE_RIGHT_COUNT 1
static const u32 ANIMATION_PLAYER_LUNGE_RIGHT_FRAME_INDICES[ANIMATION_PLAYER_LUNGE_RIGHT_COUNT] = {9};
static const struct Animation ANIMATION_PLAYER_LUNGE_RIGHT_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_LUNGE_RIGHT_FRAME_INDICES,
	.count = ANIMATION_PLAYER_LUNGE_RIGHT_COUNT,
	.length = 0,
	.isLoop = true
};


#define ANIMATION_PLAYER_IDLE_UP_COUNT 1
static const u32 ANIMATION_PLAYER_IDLE_UP_FRAME_INDICES[ANIMATION_PLAYER_IDLE_UP_COUNT] = {10};
static const struct Animation ANIMATION_PLAYER_IDLE_UP_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_IDLE_UP_FRAME_INDICES,
	.count = ANIMATION_PLAYER_IDLE_UP_COUNT,
	.length = 0,
	.isLoop = true
};

#define ANIMATION_PLAYER_RUN_UP_COUNT 3
static const u32 ANIMATION_PLAYER_RUN_UP_FRAME_INDICES[ANIMATION_PLAYER_RUN_UP_COUNT] = {11, 12, 13};
static const struct Animation ANIMATION_PLAYER_RUN_UP_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_RUN_UP_FRAME_INDICES,
	.count = ANIMATION_PLAYER_RUN_UP_COUNT,
	.length = 20,
	.isLoop = true
};

#define ANIMATION_PLAYER_LUNGE_UP_COUNT 1
static const u32 ANIMATION_PLAYER_LUNGE_UP_FRAME_INDICES[ANIMATION_PLAYER_LUNGE_UP_COUNT] = {14};
static const struct Animation ANIMATION_PLAYER_LUNGE_UP_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_LUNGE_UP_FRAME_INDICES,
	.count = ANIMATION_PLAYER_LUNGE_UP_COUNT,
	.length = 0,
	.isLoop = true
};

#define ANIMATION_PLAYER_IDLE_DOWN_COUNT 1
static const u32 ANIMATION_PLAYER_IDLE_DOWN_FRAME_INDICES[ANIMATION_PLAYER_IDLE_DOWN_COUNT] = {15};
static const struct Animation ANIMATION_PLAYER_IDLE_DOWN_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_IDLE_DOWN_FRAME_INDICES,
	.count = ANIMATION_PLAYER_IDLE_DOWN_COUNT,
	.length = 0,
	.isLoop = true
};

#define ANIMATION_PLAYER_RUN_DOWN_COUNT 3
static const u32 ANIMATION_PLAYER_RUN_DOWN_FRAME_INDICES[ANIMATION_PLAYER_RUN_DOWN_COUNT] = {16, 17, 18};
static const struct Animation ANIMATION_PLAYER_RUN_DOWN_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_RUN_DOWN_FRAME_INDICES,
	.count = ANIMATION_PLAYER_RUN_DOWN_COUNT,
	.length = 20,
	.isLoop = true
};

#define ANIMATION_PLAYER_LUNGE_DOWN_COUNT 1
static const u32 ANIMATION_PLAYER_LUNGE_DOWN_FRAME_INDICES[ANIMATION_PLAYER_LUNGE_DOWN_COUNT] = {19};
static const struct Animation ANIMATION_PLAYER_LUNGE_DOWN_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_PLAYER_LUNGE_DOWN_FRAME_INDICES,
	.count = ANIMATION_PLAYER_LUNGE_DOWN_COUNT,
	.length = 0,
	.isLoop = true
};

static const struct Animation ANIMATION_PLAYER_STRUCTS[ANIMATION_PLAYER_COUNT] = 
{
	ANIMATION_PLAYER_IDLE_LEFT_STRUCT,
	ANIMATION_PLAYER_RUN_LEFT_STRUCT,
	ANIMATION_PLAYER_LUNGE_LEFT_STRUCT,
	ANIMATION_PLAYER_IDLE_RIGHT_STRUCT,
	ANIMATION_PLAYER_RUN_RIGHT_STRUCT,
	ANIMATION_PLAYER_LUNGE_RIGHT_STRUCT,
	ANIMATION_PLAYER_IDLE_UP_STRUCT,
	ANIMATION_PLAYER_RUN_UP_STRUCT,
	ANIMATION_PLAYER_LUNGE_UP_STRUCT,
	ANIMATION_PLAYER_IDLE_DOWN_STRUCT,
	ANIMATION_PLAYER_RUN_DOWN_STRUCT,
	ANIMATION_PLAYER_LUNGE_DOWN_STRUCT
};

typedef struct ComponentAnimationPlayer
{
	Component component;
	AnimationPlayerType type;
	AnimationPlayerActionType action;
} ComponentAnimationPlayer;

void component_animation_player_init(ComponentAnimationPlayer* self, ECS* ecs, AnimationPlayerType type);
void component_animation_player_tick(ComponentAnimationPlayer* self, ECS* ecs);

static const ComponentInfo COMPONENT_ANIMATION_PLAYER_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL,
			(ECSFunction)component_animation_player_tick,
			NULL,
			NULL
		}
	},
	.type = COMPONENT_ANIMATION_PLAYER,
	.size = sizeof(ComponentAnimationPlayer)
};
