#pragma once

#include "component_animation.h"
#include "../game/component_food.h"
#include "../game/component_take_food.h"
#include "../game/component_stage.h"
#include "../game/component_world_object.h"

static const f32 ANIMATION_TARGET_POINT_RADIUS = 1500.0f;

#define ANIMATION_TARGET_COUNT (ANIMATION_TARGET_BURP_STAGE_FIVE + 1)
typedef enum AnimationTargetType
{
	ANIMATION_TARGET_IDLE_STAGE_ONE,
	ANIMATION_TARGET_POINT_STAGE_ONE,
	ANIMATION_TARGET_GULP_STAGE_ONE,
	ANIMATION_TARGET_BURP_STAGE_ONE,
	ANIMATION_TARGET_IDLE_STAGE_TWO,
	ANIMATION_TARGET_POINT_STAGE_TWO,
	ANIMATION_TARGET_GULP_STAGE_TWO,
	ANIMATION_TARGET_BURP_STAGE_TWO,
	ANIMATION_TARGET_IDLE_STAGE_THREE,
	ANIMATION_TARGET_POINT_STAGE_THREE,
	ANIMATION_TARGET_GULP_STAGE_THREE,
	ANIMATION_TARGET_BURP_STAGE_THREE,
	ANIMATION_TARGET_IDLE_STAGE_FOUR,
	ANIMATION_TARGET_POINT_STAGE_FOUR,
	ANIMATION_TARGET_GULP_STAGE_FOUR,
	ANIMATION_TARGET_BURP_STAGE_FOUR,
	ANIMATION_TARGET_IDLE_STAGE_FIVE,
	ANIMATION_TARGET_POINT_STAGE_FIVE,
	ANIMATION_TARGET_GULP_STAGE_FIVE,
	ANIMATION_TARGET_BURP_STAGE_FIVE
} AnimationTargetType;

#define ANIMATION_TARGET_ACTION_COUNT (ANIMATION_TARGET_ACTION_BURP + 1)
typedef enum AnimationTargetActionType
{
	ANIMATION_TARGET_ACTION_IDLE,
	ANIMATION_TARGET_ACTION_POINT,
	ANIMATION_TARGET_ACTION_GULP,
	ANIMATION_TARGET_ACTION_BURP
} AnimationTargetActionType;

#define ANIMATION_TARGET_IDLE_STAGE_ONE_COUNT 2
static const u32 ANIMATION_TARGET_IDLE_STAGE_ONE_FRAME_INDICES[ANIMATION_TARGET_IDLE_STAGE_ONE_COUNT] = {0, 1};
static const struct Animation ANIMATION_TARGET_IDLE_STAGE_ONE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_IDLE_STAGE_ONE_FRAME_INDICES,
	.count = ANIMATION_TARGET_IDLE_STAGE_ONE_COUNT,
	.length = 30,
	.isLoop = true
};

#define ANIMATION_TARGET_POINT_STAGE_ONE_COUNT 1
static const u32 ANIMATION_TARGET_POINT_STAGE_ONE_FRAME_INDICES[ANIMATION_TARGET_POINT_STAGE_ONE_COUNT] = {2};
static const struct Animation ANIMATION_TARGET_POINT_STAGE_ONE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_POINT_STAGE_ONE_FRAME_INDICES,
	.count = ANIMATION_TARGET_POINT_STAGE_ONE_COUNT,
	.length = 0,
	.isLoop = true
};

#define ANIMATION_TARGET_GULP_STAGE_ONE_COUNT 1
static const u32 ANIMATION_TARGET_GULP_STAGE_ONE_FRAME_INDICES[ANIMATION_TARGET_GULP_STAGE_ONE_COUNT] = {3};
static const struct Animation ANIMATION_TARGET_GULP_STAGE_ONE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_GULP_STAGE_ONE_FRAME_INDICES,
	.count = ANIMATION_TARGET_GULP_STAGE_ONE_COUNT,
	.length = 60,
	.isLoop = false
};

#define ANIMATION_TARGET_BURP_STAGE_ONE_COUNT 1
static const u32 ANIMATION_TARGET_BURP_STAGE_ONE_FRAME_INDICES[ANIMATION_TARGET_BURP_STAGE_ONE_COUNT] = {4};
static const struct Animation ANIMATION_TARGET_BURP_STAGE_ONE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_BURP_STAGE_ONE_FRAME_INDICES,
	.count = ANIMATION_TARGET_BURP_STAGE_ONE_COUNT,
	.length = 60,
	.isLoop = false
};

#define ANIMATION_TARGET_IDLE_STAGE_TWO_COUNT 2
static const u32 ANIMATION_TARGET_IDLE_STAGE_TWO_FRAME_INDICES[ANIMATION_TARGET_IDLE_STAGE_TWO_COUNT] = {5, 6};
static const struct Animation ANIMATION_TARGET_IDLE_STAGE_TWO_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_IDLE_STAGE_TWO_FRAME_INDICES,
	.count = ANIMATION_TARGET_IDLE_STAGE_TWO_COUNT,
	.length = 30,
	.isLoop = true
};

#define ANIMATION_TARGET_POINT_STAGE_TWO_COUNT 1
static const u32 ANIMATION_TARGET_POINT_STAGE_TWO_FRAME_INDICES[ANIMATION_TARGET_POINT_STAGE_TWO_COUNT] = {7};
static const struct Animation ANIMATION_TARGET_POINT_STAGE_TWO_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_POINT_STAGE_TWO_FRAME_INDICES,
	.count = ANIMATION_TARGET_POINT_STAGE_TWO_COUNT,
	.length = 0,
	.isLoop = true
};

#define ANIMATION_TARGET_GULP_STAGE_TWO_COUNT 1
static const u32 ANIMATION_TARGET_GULP_STAGE_TWO_FRAME_INDICES[ANIMATION_TARGET_GULP_STAGE_TWO_COUNT] = {8};
static const struct Animation ANIMATION_TARGET_GULP_STAGE_TWO_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_GULP_STAGE_TWO_FRAME_INDICES,
	.count = ANIMATION_TARGET_GULP_STAGE_TWO_COUNT,
	.length = 60,
	.isLoop = false
};

#define ANIMATION_TARGET_BURP_STAGE_TWO_COUNT 1
static const u32 ANIMATION_TARGET_BURP_STAGE_TWO_FRAME_INDICES[ANIMATION_TARGET_BURP_STAGE_TWO_COUNT] = {9};
static const struct Animation ANIMATION_TARGET_BURP_STAGE_TWO_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_BURP_STAGE_TWO_FRAME_INDICES,
	.count = ANIMATION_TARGET_BURP_STAGE_TWO_COUNT,
	.length = 60,
	.isLoop = false
};

#define ANIMATION_TARGET_IDLE_STAGE_THREE_COUNT 2
static const u32 ANIMATION_TARGET_IDLE_STAGE_THREE_FRAME_INDICES[ANIMATION_TARGET_IDLE_STAGE_THREE_COUNT] = {10, 11};
static const struct Animation ANIMATION_TARGET_IDLE_STAGE_THREE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_IDLE_STAGE_THREE_FRAME_INDICES,
	.count = ANIMATION_TARGET_IDLE_STAGE_THREE_COUNT,
	.length = 30,
	.isLoop = true
};

#define ANIMATION_TARGET_POINT_STAGE_THREE_COUNT 1
static const u32 ANIMATION_TARGET_POINT_STAGE_THREE_FRAME_INDICES[ANIMATION_TARGET_POINT_STAGE_THREE_COUNT] = {12};
static const struct Animation ANIMATION_TARGET_POINT_STAGE_THREE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_POINT_STAGE_THREE_FRAME_INDICES,
	.count = ANIMATION_TARGET_POINT_STAGE_THREE_COUNT,
	.length = 0,
	.isLoop = true
};

#define ANIMATION_TARGET_GULP_STAGE_THREE_COUNT 1
static const u32 ANIMATION_TARGET_GULP_STAGE_THREE_FRAME_INDICES[ANIMATION_TARGET_GULP_STAGE_THREE_COUNT] = {13};
static const struct Animation ANIMATION_TARGET_GULP_STAGE_THREE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_GULP_STAGE_THREE_FRAME_INDICES,
	.count = ANIMATION_TARGET_GULP_STAGE_THREE_COUNT,
	.length = 60,
	.isLoop = false
};

#define ANIMATION_TARGET_BURP_STAGE_THREE_COUNT 1
static const u32 ANIMATION_TARGET_BURP_STAGE_THREE_FRAME_INDICES[ANIMATION_TARGET_BURP_STAGE_THREE_COUNT] = {14};
static const struct Animation ANIMATION_TARGET_BURP_STAGE_THREE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_BURP_STAGE_THREE_FRAME_INDICES,
	.count = ANIMATION_TARGET_BURP_STAGE_THREE_COUNT,
	.length = 60,
	.isLoop = false
};

#define ANIMATION_TARGET_IDLE_STAGE_FOUR_COUNT 2
static const u32 ANIMATION_TARGET_IDLE_STAGE_FOUR_FRAME_INDICES[ANIMATION_TARGET_IDLE_STAGE_FOUR_COUNT] = {15, 16};
static const struct Animation ANIMATION_TARGET_IDLE_STAGE_FOUR_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_IDLE_STAGE_FOUR_FRAME_INDICES,
	.count = ANIMATION_TARGET_IDLE_STAGE_FOUR_COUNT,
	.length = 30,
	.isLoop = true
};

#define ANIMATION_TARGET_POINT_STAGE_FOUR_COUNT 1
static const u32 ANIMATION_TARGET_POINT_STAGE_FOUR_FRAME_INDICES[ANIMATION_TARGET_POINT_STAGE_FOUR_COUNT] = {17};
static const struct Animation ANIMATION_TARGET_POINT_STAGE_FOUR_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_POINT_STAGE_FOUR_FRAME_INDICES,
	.count = ANIMATION_TARGET_POINT_STAGE_FOUR_COUNT,
	.length = 0,
	.isLoop = true
};

#define ANIMATION_TARGET_GULP_STAGE_FOUR_COUNT 1
static const u32 ANIMATION_TARGET_GULP_STAGE_FOUR_FRAME_INDICES[ANIMATION_TARGET_GULP_STAGE_FOUR_COUNT] = {18};
static const struct Animation ANIMATION_TARGET_GULP_STAGE_FOUR_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_GULP_STAGE_FOUR_FRAME_INDICES,
	.count = ANIMATION_TARGET_GULP_STAGE_FOUR_COUNT,
	.length = 60,
	.isLoop = false
};

#define ANIMATION_TARGET_BURP_STAGE_FOUR_COUNT 1
static const u32 ANIMATION_TARGET_BURP_STAGE_FOUR_FRAME_INDICES[ANIMATION_TARGET_BURP_STAGE_FOUR_COUNT] = {19};
static const struct Animation ANIMATION_TARGET_BURP_STAGE_FOUR_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_BURP_STAGE_FOUR_FRAME_INDICES,
	.count = ANIMATION_TARGET_BURP_STAGE_FOUR_COUNT,
	.length = 60,
	.isLoop = false
};

#define ANIMATION_TARGET_IDLE_STAGE_FIVE_COUNT 2
static const u32 ANIMATION_TARGET_IDLE_STAGE_FIVE_FRAME_INDICES[ANIMATION_TARGET_IDLE_STAGE_FIVE_COUNT] = {20, 21};
static const struct Animation ANIMATION_TARGET_IDLE_STAGE_FIVE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_IDLE_STAGE_FIVE_FRAME_INDICES,
	.count = ANIMATION_TARGET_IDLE_STAGE_FIVE_COUNT,
	.length = 30,
	.isLoop = true
};

#define ANIMATION_TARGET_POINT_STAGE_FIVE_COUNT 1
static const u32 ANIMATION_TARGET_POINT_STAGE_FIVE_FRAME_INDICES[ANIMATION_TARGET_POINT_STAGE_FIVE_COUNT] = {22};
static const struct Animation ANIMATION_TARGET_POINT_STAGE_FIVE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_POINT_STAGE_FIVE_FRAME_INDICES,
	.count = ANIMATION_TARGET_POINT_STAGE_FIVE_COUNT,
	.length = 0,
	.isLoop = true
};

#define ANIMATION_TARGET_GULP_STAGE_FIVE_COUNT 1
static const u32 ANIMATION_TARGET_GULP_STAGE_FIVE_FRAME_INDICES[ANIMATION_TARGET_GULP_STAGE_FIVE_COUNT] = {23};
static const struct Animation ANIMATION_TARGET_GULP_STAGE_FIVE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_GULP_STAGE_FIVE_FRAME_INDICES,
	.count = ANIMATION_TARGET_GULP_STAGE_FIVE_COUNT,
	.length = 60,
	.isLoop = false
};

#define ANIMATION_TARGET_BURP_STAGE_FIVE_COUNT 1
static const u32 ANIMATION_TARGET_BURP_STAGE_FIVE_FRAME_INDICES[ANIMATION_TARGET_BURP_STAGE_FIVE_COUNT] = {24};
static const struct Animation ANIMATION_TARGET_BURP_STAGE_FIVE_STRUCT = 
{
	.frameIndices = (u32*)ANIMATION_TARGET_BURP_STAGE_FIVE_FRAME_INDICES,
	.count = ANIMATION_TARGET_BURP_STAGE_FIVE_COUNT,
	.length = 60,
	.isLoop = false
};

static const struct Animation ANIMATION_TARGET_STRUCTS[ANIMATION_TARGET_COUNT] = 
{
	ANIMATION_TARGET_IDLE_STAGE_ONE_STRUCT,
	ANIMATION_TARGET_POINT_STAGE_ONE_STRUCT,
	ANIMATION_TARGET_GULP_STAGE_ONE_STRUCT,
	ANIMATION_TARGET_BURP_STAGE_ONE_STRUCT,
	ANIMATION_TARGET_IDLE_STAGE_TWO_STRUCT,
	ANIMATION_TARGET_POINT_STAGE_TWO_STRUCT,
	ANIMATION_TARGET_GULP_STAGE_TWO_STRUCT,
	ANIMATION_TARGET_BURP_STAGE_TWO_STRUCT,
	ANIMATION_TARGET_IDLE_STAGE_THREE_STRUCT,
	ANIMATION_TARGET_POINT_STAGE_THREE_STRUCT,
	ANIMATION_TARGET_GULP_STAGE_THREE_STRUCT,
	ANIMATION_TARGET_BURP_STAGE_THREE_STRUCT,
	ANIMATION_TARGET_IDLE_STAGE_FOUR_STRUCT,
	ANIMATION_TARGET_POINT_STAGE_FOUR_STRUCT,
	ANIMATION_TARGET_GULP_STAGE_FOUR_STRUCT,
	ANIMATION_TARGET_BURP_STAGE_FOUR_STRUCT,
	ANIMATION_TARGET_IDLE_STAGE_FIVE_STRUCT,
	ANIMATION_TARGET_POINT_STAGE_FIVE_STRUCT,
	ANIMATION_TARGET_GULP_STAGE_FIVE_STRUCT,
	ANIMATION_TARGET_BURP_STAGE_FIVE_STRUCT
};

typedef struct ComponentAnimationTarget
{
	Component component;
	AnimationTargetType type;
	AnimationTargetActionType action;
	EntityID playerID;
	bool isPointDisabled;
} ComponentAnimationTarget;

void component_animation_target_init(ComponentAnimationTarget* self, ECS* ecs, AnimationTargetType type, EntityID playerID);
void component_animation_target_tick(ComponentAnimationTarget* self, ECS* ecs);

static const ComponentInfo COMPONENT_ANIMATION_TARGET_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL,
			(ECSFunction)component_animation_target_tick,
			NULL,
			NULL
		}
	},
	.type = COMPONENT_ANIMATION_TARGET,
	.size = sizeof(ComponentAnimationTarget)
};
