#include "component_collide_slow.h"

void _component_collide_slow_collisions_tick(ComponentCollideSlow* self, ECS* ecs);

void
_component_collide_slow_collisions_tick(ComponentCollideSlow* self, ECS* ecs)
{
	ComponentCircleCollider* circleCollider;

	circleCollider = ecs_component_get(ecs, COMPONENT_CIRCLE_COLLIDER, self->component.id);

	self->isPreviousColliding = self->isColliding;
	self->isColliding = false;

	ecs->isLog = false;

	for (s32 i = 0; i < (s32)circleCollider->collisions.count; i++)
	{
		ComponentPhysics* collidePhysics;
		ComponentWorldObject* collideWorldObject;
		EntityID* id;
		f32 angle;
		f32 distance;

		id = vector_get(&circleCollider->collisions, i);

		collidePhysics = ecs_component_get(ecs, COMPONENT_PHYSICS, *id);
		collideWorldObject = ecs_component_get(ecs, COMPONENT_WORLD_OBJECT, *id);

		if (!collideWorldObject || !collidePhysics)
			continue;

		if (!collideWorldObject->isAirborne)
		{
			collidePhysics->velocity[0] *= COMPONENT_COLLIDE_SLOW_VELOCITY_MULTIPLIER;
			collidePhysics->velocity[1] *= COMPONENT_COLLIDE_SLOW_VELOCITY_MULTIPLIER;

			self->isColliding = true;
		}
	}

	if (self->isPreviousColliding != self->isColliding)
		sound_play(&ecs->resources->sounds[SOUND_STICKY]);

	ecs->isLog = true;
}

void
component_collide_slow_tick(ComponentCollideSlow* self, ECS* ecs)
{
	_component_collide_slow_collisions_tick(self, ecs);	
}
