#include "component_game_object.h"

void
component_game_object_init
(
	ComponentGameObject* self, 
	ECS* ecs,
	Texture* texture, 
	RendererBuffer buffer,
	Origin origin,
	vec2 size, 
	vec3 position
)
{
	ComponentPhysics* physics;

	physics = ecs_component_get(ecs, COMPONENT_PHYSICS, self->component.id);

	component_texture_quad_init
	(
		ecs_component_get(ecs, COMPONENT_TEXTURE_QUAD, self->component.id),
		ecs, 
		texture, 
		COMPONENT_TEXTURE_QUAD_FLIP_DEFAULT,
		origin,
		buffer,
		COMPONENT_TEXTURE_QUAD_ROTATION_DEFAULT,
		size, 
		COMPONENT_TEXTURE_QUAD_SCALE_DEFAULT,
		COMPONENT_TEXTURE_QUAD_UV_MIN_DEFAULT,
		COMPONENT_TEXTURE_QUAD_UV_MAX_DEFAULT,
		COMPONENT_TEXTURE_QUAD_OFFSET_DEFAULT,
		position,
		COMPONENT_TEXTURE_QUAD_COLOR_DEFAULT
	);

	glm_vec3_copy(position, physics->position);
}

void
component_game_object_add(ComponentGameObject* self, ECS* ecs)
{
	ecs_components_add
	(
		ecs, 
		COMPONENT_GAME_OBJECT_DEPENDENCIES, 
		COMPONENT_GAME_OBJECT_DEPENDENCY_COUNT, 
		self->component.id
	);
}

void
component_game_object_tick(ComponentGameObject* self, ECS* ecs)
{
	ComponentTextureQuad* textureQuad;
	ComponentPhysics* physics;

	textureQuad = ecs_component_get(ecs, COMPONENT_TEXTURE_QUAD, self->component.id);
	physics = ecs_component_get(ecs, COMPONENT_PHYSICS, self->component.id);

	glm_vec3_copy(physics->position, textureQuad->position);
}
