#include "component_homing.h"

void
component_homing_init(ComponentHoming* self, ECS* ecs, EntityID targetID, f32 speed)
{
	self->targetID = targetID;
	self->speed = speed;
	self->isHoming = true;
}

void
component_homing_tick(ComponentHoming* self, ECS* ecs)
{
	if (!self->isHoming)
		return;

	ComponentPhysics* physics;
	ComponentPhysics* targetPhysics;
	f32 angle;
	
	physics = ecs_component_get(ecs, COMPONENT_PHYSICS, self->component.id);
	targetPhysics = ecs_component_get(ecs, COMPONENT_PHYSICS, self->targetID);
	
	if (!targetPhysics)
		return;

	angle = ATAN(physics->position[0], targetPhysics->position[0], physics->position[1], targetPhysics->position[1]);

	physics->velocity[0] += self->speed * cos(angle);
	physics->velocity[1] += self->speed * sin(angle);
}
