#pragma once

#include "component_world_object.h"
#include "component_stamina.h"

#include "../../entity/visual/entity_sprite.h"
#include "../../entity/utility/entity_timer.h"

static const f32 COMPONENT_PLAYER_CONTROL_VELOCITY_DEFAULT = 1.0f;
static const f32 COMPONENT_PLAYER_CONTROL_VELOCITY_DISTANCE_MAX = 500.0f;
static const f32 COMPONENT_PLAYER_CONTROL_VELOCITY_IN_CIRCLE_MULTIPLIER = 0.9f;
static const f32 COMPONENT_PLAYER_CONTROL_VELOCITY_STOP_THRESHOLD = 3.0f;
static const f32 COMPONENT_PLAYER_CONTROL_LUNGE_VELOCITY = 50.0f;
static const f32 COMPONENT_PLAYER_CONTROL_LUNGE_HEIGHT_OFFSET_VELOCITY = 10.0f;
static const s32 COMPONENT_PLAYER_CONTROL_LUNGE_STAMINA_COST = 25;
static const s32 COMPONENT_PLAYER_CONTROL_LUNGE_TIMER_MAX = 10;

typedef struct ComponentPlayerControl
{
	Component component;
	bool isLunge;
	EntityID lungeTimerID;
} ComponentPlayerControl;

void component_player_control_add(ComponentPlayerControl* self, ECS* ecs);
void component_player_control_tick(ComponentPlayerControl* self, ECS* ecs);

#define COMPONENT_PLAYER_CONTROL_DEPENDENCY_COUNT 2
static const ComponentType COMPONENT_PLAYER_CONTROL_DEPENDENCIES[COMPONENT_PLAYER_CONTROL_DEPENDENCY_COUNT] = 
{
	COMPONENT_WORLD_OBJECT,
	COMPONENT_STAMINA,
};

static const ComponentInfo COMPONENT_PLAYER_CONTROL_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			(ECSFunction)component_player_control_add, 
			NULL,
			(ECSFunction)component_player_control_tick, 
			NULL,
			NULL
		}
	},
	.type = COMPONENT_PLAYER_CONTROL,
	.size = sizeof(ComponentPlayerControl)
};
