#include "component_solid.h"

void _component_solid_collisions_tick(ComponentSolid* self, ECS* ecs);

void
_component_solid_collisions_tick(ComponentSolid* self, ECS* ecs)
{
	ComponentCircleCollider* circleCollider;
	ComponentPhysics* physics;

	circleCollider = ecs_component_get(ecs, COMPONENT_CIRCLE_COLLIDER, self->component.id);
	physics = ecs_component_get(ecs, COMPONENT_PHYSICS, self->component.id);

	for (s32 i = 0; i < (s32)circleCollider->collisions.count; i++)
	{
		ComponentPhysics* collidePhysics;
		ComponentCircleCollider* collideCircleCollider;
		EntityID* id;
		f32 angle;

		id = vector_get(&circleCollider->collisions, i);

		collidePhysics = ecs_component_get(ecs, COMPONENT_PHYSICS, *id);
		collideCircleCollider = ecs_component_get(ecs, COMPONENT_CIRCLE_COLLIDER, *id);

		angle = ATAN
		(
			physics->position[0], 
			collidePhysics->position[0], 
			physics->position[1],
			collidePhysics->position[1]
		);

		collidePhysics->position[0] = physics->position[0] + ((circleCollider->circle.radius * 2) * cos(angle));
		collidePhysics->position[1] = physics->position[1] + ((circleCollider->circle.radius * 2) * sin(angle));

		collidePhysics->position[0] += (collideCircleCollider->circle.radius * 2) * cos(angle);
		collidePhysics->position[1] += (collideCircleCollider->circle.radius * 2) * sin(angle);
	}
}

void
component_solid_tick(ComponentSolid* self, ECS* ecs)
{
	_component_solid_collisions_tick(self, ecs);	
}
