#pragma once

#include "../../ecs_entity.h"

typedef struct ComponentStamina
{
	Component component;
	f32 value;
	f32 max;
	f32 gain;
} ComponentStamina;

void component_stamina_tick(ComponentStamina* self, ECS* ecs);
void component_stamina_init(ComponentStamina* self, ECS* ecs, f32 max, f32 gain);

static const ComponentInfo COMPONENT_STAMINA_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL,
			(ECSFunction)component_stamina_tick, 
			NULL,
			NULL
		}
	},
	.type = COMPONENT_STAMINA,
	.size = sizeof(ComponentStamina)
};
