#include "component_atlas.h"

void 
component_atlas_uv_get(ComponentAtlas* self, Texture* texture, vec2 uvMin, vec2 uvMax)
{
	vec2 position;

	position[0] = (self->index % self->size[1]) * self->frameSize[0];
	position[1] = (s32)((f32)self->index / self->size[1]) * self->frameSize[1];

	uvMin[0] = (f32)position[0] / texture->size[0];
	uvMin[1] = (f32)position[1] / texture->size[1];
	uvMax[0] = (f32)(position[0] + self->frameSize[0]) / texture->size[0];
	uvMax[1] = (f32)(position[1] + self->frameSize[1]) / texture->size[1];
}

void
component_atlas_init(ComponentAtlas* self, ECS* ecs, const ivec2 frameSize, const ivec2 size, u32 index)
{
	glm_ivec2_copy((s32*)frameSize, self->frameSize);
	glm_ivec2_copy((s32*)size, self->size);
	self->index = index;
}

void
component_atlas_tick(ComponentAtlas* self, ECS* ecs)
{
	ComponentTextureQuad* textureQuad;

	textureQuad = ecs_component_get(ecs, COMPONENT_TEXTURE_QUAD, self->component.id);

	component_atlas_uv_get(self, textureQuad->texture, textureQuad->uvMin, textureQuad->uvMax);
}
