#pragma once

#include "component_texture_quad.h"
#include "component_text.h"
#include "../../entity/utility/entity_timer.h"

typedef struct ComponentColorChange
{
	Component component;
	vec4 beginColor;
	vec4 endColor;
	vec4 returnColor;
	vec4 colorStep;
	bool isColorCover;
	bool isReturn;
	bool isFinished;
	EntityID timerID;
} ComponentColorChange;

void component_color_change_add(ComponentColorChange* self, ECS* ecs);
void component_color_change_delete(ComponentColorChange* self, ECS* ecs);
void component_color_change_tick(ComponentColorChange* self, ECS* ecs);

void
component_color_change_init
(
	ComponentColorChange* self, 
	ECS* ecs,
	const vec4 endColor,
	const vec4 beginColor,
	u32 length,
	bool isColorCover,
	bool isReturn
);

static const ComponentInfo COMPONENT_COLOR_CHANGE_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			(ECSFunction)component_color_change_add,
			(ECSFunction)component_color_change_delete,
			(ECSFunction)component_color_change_tick,
			NULL,
			NULL
		}
	},
	.type = COMPONENT_COLOR_CHANGE,
	.size = sizeof(ComponentColorChange)
};
