#include "component_pulsate.h"

void
component_pulsate_add(ComponentPulsate* self, ECS* ecs)
{
	self->counterID = entity_counter_add(ecs);
}

void
component_pulsate_delete(ComponentPulsate* self, ECS* ecs)
{
	ecs_entity_delete(ecs, self->counterID);
}

void
component_pulsate_tick(ComponentPulsate* self, ECS* ecs)
{
	ComponentCounter* counter;
	ComponentTextureQuad* textureQuad;

	counter = ecs_component_get(ecs, COMPONENT_COUNTER, self->counterID);
	textureQuad = ecs_component_get(ecs, COMPONENT_TEXTURE_QUAD, self->component.id);

	textureQuad->scale[0] = 1 + ((self->maxScale[0] - self->minScale[0]) / 2.0f) * cos((f32)counter->value / self->frequency);
	textureQuad->scale[1] = 1 + ((self->maxScale[1] - self->minScale[1]) / 2.0f) * cos((f32)counter->value / self->frequency);
}

void
component_pulsate_init
(
 	ComponentPulsate* self,
	ECS* ecs,
	vec2 minScale,
	vec2 maxScale,
	f32 frequency
)
{
	self->frequency = frequency;

	glm_vec2_copy(minScale, self->minScale);
	glm_vec2_copy(maxScale, self->maxScale);
}
