#pragma once

#include "component_texture_quad.h"

typedef struct ComponentScaleValue
{
	Component component;
	vec2 minSize;
	vec2 maxSize;
	ComponentType type;
	EntityID id;
} ComponentScaleValue;

void component_scale_value_init(ComponentScaleValue* self, ECS* ecs, vec2 minSize, vec2 maxSize, ComponentType type, EntityID id);
void component_scale_value_tick(ComponentScaleValue* self, ECS* ecs);

static const ComponentInfo COMPONENT_SCALE_VALUE_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL,
			(ECSFunction)component_scale_value_tick,
			NULL,
			NULL
		}
	},
	.type = COMPONENT_SCALE_VALUE,
	.size = sizeof(ComponentScaleValue)
};

