#pragma once

#include "component_text.h"
#include "../../../../engine/time.h"

#define COMPONENT_VALUE_TEXT_STRING_MAX 64

typedef enum ComponentValueTextType
{
	COMPONENT_VALUE_TEXT_TYPE_INTEGER,
	COMPONENT_VALUE_TEXT_TYPE_INTEGER_MAX,
	COMPONENT_VALUE_TEXT_TYPE_TIMER,
} ComponentValueTextType;

typedef struct ComponentValueText
{
	Component component;
	ComponentType type;
	ComponentValueTextType textType;
	EntityID id;
	const char* format;
	s32 previousValue;
	s32 value;
} ComponentValueText;

void component_value_text_add(ComponentValueText* self, ECS* ecs);
void component_value_text_tick(ComponentValueText* self, ECS* ecs);

void
component_value_text_init
(
	ComponentValueText* self, 
	ECS* ecs,
	Font* font,
	RendererBuffer buffer,
	const vec3 position,
	ComponentType type,
	ComponentValueTextType textType,
	const char* format,
	EntityID id
);

#define COMPONENT_VALUE_TEXT_DEPENDENCY_COUNT 1
static const ComponentType COMPONENT_VALUE_TEXT_DEPENDENCIES[COMPONENT_VALUE_TEXT_DEPENDENCY_COUNT] = 
{
	COMPONENT_TEXT
};

static const ComponentInfo COMPONENT_VALUE_TEXT_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			(ECSFunction)component_value_text_add, 
			NULL,
			(ECSFunction)component_value_text_tick,
			NULL,
			NULL
		}
	},
	.type = COMPONENT_VALUE_TEXT,
	.size = sizeof(ComponentText)
};
