#pragma once

#include "../visual/entity_sprite_atlas.h"

#include "../../component/utility/component_delete_on_timer.h"
#include "../../component/animation/component_animation.h"

#define ENTITY_SMOKE_ANIMATION_COUNT 8
static const u32 ENTITY_SMOKE_ANIMATION_FRAME_INDICES[ENTITY_SMOKE_ANIMATION_COUNT] = {0, 1, 2, 3, 4, 5, 6, 7};
static const struct Animation ENTITY_SMOKE_ANIMATION =
{
	.frameIndices = (u32*)ENTITY_SMOKE_ANIMATION_FRAME_INDICES,
	.count = ENTITY_SMOKE_ANIMATION_COUNT,
	.length = 5,
	.isLoop = false
};

static const vec2 ENTITY_SMOKE_SIZE = {256.0f, 256.0f};
static const ivec2 ENTITY_SMOKE_ATLAS_FRAME_SIZE = {128, 128};
static const ivec2 ENTITY_SMOKE_ATLAS_SIZE = {1, 8};
static const s32 ENTITY_SMOKE_TIMER = 45;

static const f32 ENTITY_SMOKE_VELOCITY = 100.0f;

#define ENTITY_SMOKE_DEPENDENCY_COUNT 2
static const ComponentType ENTITY_SMOKE_DEPENDENCIES[ENTITY_SMOKE_DEPENDENCY_COUNT] =
{
	COMPONENT_DELETE_ON_TIMER,
	COMPONENT_ANIMATION,
};

EntityID entity_smoke_add(ECS* ecs, vec3 position);
