#pragma once

#include "../../component/physics/component_copy_mouse_position.h"
#include "../../component/visual/component_pulsate.h"
#include "../../component/game/component_game_object.h"

EntityID entity_cursor_add(ECS* ecs);

#define ENTITY_CURSOR_DEPENDENCY_COUNT 3
static const ComponentType ENTITY_CURSOR_DEPENDENCIES[ENTITY_CURSOR_DEPENDENCY_COUNT] =
{
	COMPONENT_GAME_OBJECT,
	COMPONENT_COPY_MOUSE_POSITION,
	COMPONENT_PULSATE,
};

static const RendererBuffer ENTITY_CURSOR_BUFFER = RENDERER_BUFFER_CURSOR;
static const vec2 ENTITY_CURSOR_SIZE = {32.0f, 32.0f};
static const vec3 ENTITY_CURSOR_POSITION = {0.0f, 0.0f, 0.0f};
static const vec2 ENTITY_CURSOR_PULSATE_MAX_SCALE = {1.1f, 1.1f};
static const vec2 ENTITY_CURSOR_PULSATE_MIN_SCALE = {0.90f, 0.90f};
static const f32 ENTITY_CURSOR_PULSATE_FREQUENCY = 5.0f;

