#pragma once

#include "../visual/entity_sprite.h"
#include "../../component/visual/component_atlas.h"
#include "../../component/visual/component_color_match.h"

typedef enum LevelStatusType
{
	LEVEL_STATUS_UNLOCKED,
	LEVEL_STATUS_LOCKED,
	LEVEL_STATUS_BRONZE,
	LEVEL_STATUS_SILVER,
	LEVEL_STATUS_GOLD
} LevelStatusType;

#define ENTITY_LEVEL_SELECT_BUTTON_ICON_DEPENDENCY_COUNT 2
static const ComponentType ENTITY_LEVEL_SELECT_BUTTON_ICON_DEPENDENCIES[ENTITY_LEVEL_SELECT_BUTTON_ICON_DEPENDENCY_COUNT] =
{
	COMPONENT_ATLAS,
	COMPONENT_COLOR_MATCH
};

static const vec2 ENTITY_LEVEL_SELECT_BUTTON_ICON_SIZE = {64.0f, 64.0f};
static const vec3 ENTITY_LEVEL_SELECT_BUTTON_ICON_OFFSET = {48.0f, 48.0f, -0.01f};
static const ivec2 ENTITY_LEVEL_SELECT_BUTTON_ICON_ATLAS_FRAME_SIZE = {32, 32};
static const ivec2 ENTITY_LEVEL_SELECT_BUTTON_ICON_ATLAS_SIZE = {1, 5};

EntityID entity_level_select_button_icon_add
(
	ECS* ecs,
	LevelStatusType status,
	EntityID levelSelectButtonID
);
