#include "entity_text_disappearing.h"

EntityID
entity_text_disappearing_add
(
	ECS* ecs, 
	Font* font, 
	RendererBuffer buffer, 
	const char* string, 
	const vec3 position,
	u32 wrap,
	u32 timer
)
{
	EntityID id;

	id = entity_text_add
	(
		ecs,
		font,
		buffer,
		string,
		position,
		wrap
	);

	ecs_components_add(ecs, ENTITY_TEXT_DISAPPEARING_DEPENDENCIES, ENTITY_TEXT_DISAPPEARING_DEPENDENCY_COUNT, id);

	component_delete_on_timer_init
	(
		ecs_component_get(ecs, COMPONENT_DELETE_ON_TIMER, id),
		ecs,
		timer
	);

	component_color_change_init
	(
		ecs_component_get(ecs, COMPONENT_COLOR_CHANGE, id),
		ecs,
		OPAQUE,
		TRANSPARENT,
		timer,
		false,
		false
	);

	return id;
}
