#include "resource_shader.h"

typedef struct ShaderData
{
	char vertex[SHADER_BUFFER_SIZE];
	char fragment[SHADER_BUFFER_SIZE];
} ShaderData;

static ShaderData shaderData[SHADER_COUNT];

void
resource_shader_read(Resources* self)
{
	for (s32 i = 0; i < SHADER_COUNT; i++)
	{
		file_read
		(
			SHADER_PATHS[i].vertex, 
			(void*)shaderData[i].vertex, 
			SHADER_BUFFER_SIZE, 
			"r"
		); 
		
		file_read
		(
			SHADER_PATHS[i].fragment, 
			(void*)shaderData[i].fragment, 
			SHADER_BUFFER_SIZE, 
			"r"
		);
	}
}

bool
resource_shader_init(Resources* self, ShaderType type)
{
	if 
	(
		!shader_init
		(
			&self->shaders[type], 
			shaderData[type].vertex,
			shaderData[type].fragment
		)
	)
	{
		printf(STRING_RESOURCE_SHADER_ERROR, SHADER_PATHS[type].vertex, SHADER_PATHS[type].fragment);
		return false;
	}

	printf(STRING_RESOURCE_SHADER_INIT, SHADER_PATHS[type].vertex, SHADER_PATHS[type].fragment);
	return true;
}

void
resource_shader_free(Resources* self, ShaderType type)
{
	if (self->shaders[type].isInit)
	{
		shader_free(&self->shaders[type]);
		printf(STRING_RESOURCE_SHADER_FREE, SHADER_PATHS[type].vertex, SHADER_PATHS[type].fragment);
	}
}
