#include "resources.h"

bool
resources_init(Resources* self)
{
	for (s32 i = 0; i < SHADER_COUNT; i++)
		if (!resource_shader_init(self, (ShaderType)i))
			return false;

	for (s32 i = 0; i < TEXTURE_COUNT; i++)
		if (!resource_texture_init(self, (TextureType)i))
			return false;

	for (s32 i = 0; i < FONT_COUNT; i++)
		if (!resource_font_init(self, (FontType)i))
			return false;

	for (s32 i = 0; i < SOUND_COUNT; i++)
		if (!resource_sound_init(self, (SoundType)i))
			return false;

	for (s32 i = 0; i < MUSIC_COUNT; i++)
		if (!resource_music_init(self, (MusicType)i))
			return false;

	return true;
}

void
resources_free(Resources* self)
{
	for (s32 i = 0; i < SHADER_COUNT; i++)
		resource_shader_free(self, (ShaderType)i);

	for (s32 i = 0; i < TEXTURE_COUNT; i++)
		resource_texture_free(self, (TextureType)i);

	for (s32 i = 0; i < FONT_COUNT; i++)
		resource_font_free(self, (FontType)i);

	for (s32 i = 0; i < SOUND_COUNT; i++)
		resource_sound_free(self, (SoundType)i);

	for (s32 i = 0; i < MUSIC_COUNT; i++)
		resource_music_free(self, (MusicType)i);
}
