#pragma once

#include "text_queue.h"
#include "ui.h"

#define LEVEL_EVENT_OUT_OF_BREATH_STAMINA_MULTIPLIER 0.5f
#define LEVEL_EVENT_VIM_AND_VIGOR_STAMINA_MAX 99999.0f
#define LEVEL_EVENT_ANCHOR_ARMS_FOOD_MAX 50
#define LEVEL_EVENT_BUTTERFINGERS_FOOD_MAX 10
#define LEVEL_EVENT_GLUTTONY_FOOD_MULTIPLIER 2;
#define LEVEL_EVENT_FORESIGHT_POWER 25.0f
#define LEVEL_EVENT_CANCEL_POWER 25.0f
#define LEVEL_EVENT_EXTEND_POWER 25.0f
#define LEVEL_EVENT_INVIGORATE_POWER 25.0f
#define LEVEL_EVENT_MAGNET_POWER 25.0f
#define LEVEL_EVENT_PLAYER_POWER_COLOR_CHANGE_TIME 60
#define LEVEL_EVENT_POWER_MAGNET_RADIUS 3000.0f
#define LEVEL_EVENT_POWER_EXTEND_TIME 300
#define LEVEL_EVENT_STICKY_TRAPS_MIN 5
#define LEVEL_EVENT_STICKY_TRAPS_MAX 10
#define ENTITY_TRAP_SMOKE_Z_OFFSET -0.01f

static const vec4 LEVEL_EVENT_PLAYER_POWER_COLOR = {0.60f, 1.0f, 0.80f, 0.0f};
static const vec4 LEVEL_EVENT_STICKY_TRAPS_BOUNDS = {350.0f, 350.0f, 6300.0f, 3000.0f};

#define STRING_LEVEL_EVENT_CANCEL "Next event cancelled!"
#define STRING_LEVEL_EVENT_EXTEND "The current event has been extended!"
#define STRING_LEVEL_EVENT_INVIGORATE "Stamina replenished!"
#define STRING_LEVEL_EVENT_MAGNET "Magnet activated!"

static const char* STRING_LEVEL_EVENTS[LEVEL_EVENT_COUNT] = 
{
	"Event: None | Nothing happens...",
	"Event: Rotten Food | Don't collect the yucky food!", 
	"Event: Sticky Traps | Watch out for the slowing traps!", 
	"Event: Butterfingers | You can't carry as much food!", 
	"Event: Out of Breath | Your stamina maximum is halved!", 
	"Event: Power Leech | The power has been sapped out of you!", 
	"Event: Vim and Vigor | You have infinite stamina!", 
	"Event: Gluttony | Giving food to your mistress will double its value!", 
	"Event: Anchor Arms | You can carry more food!"
};

static const char* STRING_LEVEL_EVENT_FORESIGHTS[LEVEL_EVENT_COUNT] = 
{
	"You feel that you may have wasted your foresight...",
	"You sniff the scent of rotting food...", 
	"You feel the need to watch your step...", 
	"You feel your grip will be loosened...", 
	"You feel an oncoming bout of tiredness...", 
	"You feel the power within you is fleeting...", 
	"You sense an oncoming sensation of great energy...", 
	"You hear the distant rumbles of your mistress' belly...", 
	"You feel your grip will be strengthened..."
};

static const Rectangle LEVEL_EVENT_STICKY_TRAPS_NO_NO_RECTANGLE = 
{
	.x = 2500.0f,
	.y = 1400.0f,
	.w = 1800.0f,
	.h = 1400.0f
};

void level_event_init(Level* self);
void level_event_tick(Level* self);
void level_event_handle(Level* self);
void level_event_choose(Level* self);
void level_event_return(Level* self);
