#pragma once

#include "event.h"
#include "countdown.h"
#include "collectible_spawn.h"
#include "tutorial.h"
#include "pause.h"

#define LEVEL_FOLIAGE_COUNT_MIN 10
#define LEVEL_FOLIAGE_COUNT_MAX 20

static const vec3 LEVEL_TRAP_POSITION = {2500.0f, 1000.0f, 0.0f};
static const vec3 LEVEL_PLAYER_POSITION = {3275.0f, 2400.0f, 0.0f};
static const vec3 LEVEL_TARGET_POSITION = {3275.0f, 1625.0f, 0.0f};
static const vec3 LEVEL_PLANE_POSITION = {250.0f, 250.0f, 1.0f};
static const vec3 LEVEL_PLANE_SIZE = {5925.0f, 3100.0f, 0.0f};
static const vec3 LEVEL_BG_POSITION = {0.0f, 0.0f, 1.0f};
static const vec3 LEVEL_BG_SIZE = {1280.0f, 720.0f, 0.0f};
static const vec4 LEVEL_EVENT_TIMER_LOW_TICK_THRESHOLD_COLOR = {1.0f, 0.0f, 0.0f, 1.0f};

static const f32 LEVEL_FINISH_TEXT_VALUE = 60;
static const vec3 LEVEL_FINISH_TEXT_POSITION = {600.0f, 300.0f, 0.0f};
static const vec3 LEVEL_AMULET_POSITION = {6000.0f, 3200.0f, 0.0f};

#define LEVEL_FINISH_TIMER_VALUE 600
#define LEVEL_TIMER_LOW_TICK_THRESHOLD 600
#define LEVEL_FINISH_STRING_MAX 255

#define LEVEL_FINISH_TEXT_FORMAT "%s | Medal: %s | Medal time: %i'%02i\"%02i | Score: %i"
#define LEVEL_FINISH_TEXT_FAILED_FORMAT "%s | Medal: %s | Medal time: -\'--\"-- | Score: %i"

#define STRING_LEVEL_FAILED "Level failed..."
#define STRING_LEVEL_COMPLETE "Level complete!"
#define STRING_LEVEL_MEDAL_GOLD "Gold"
#define STRING_LEVEL_MEDAL_SILVER "Silver"
#define STRING_LEVEL_MEDAL_BRONZE "Bronze"
#define STRING_LEVEL_MEDAL_NONE "None"
#define STRING_LEVEL_FINISH "FINISH!"

void level_init(Level* self, ECS* ecs, LevelSettings settings, u32 levelValue);
void level_tick(Level* self);
void level_free(Level* self);
